#include "cora_fit.h"

#include <stdlib.h>
#include <stdio.h>

/*  ------------------------ */

void vec_init(Vector *x)
{
  x->vec=NULL;
  x->len=0;
  return;
}


/*  ------------------------ */ 

void vec_alloc(Vector *x, int n)
{
  int i;
  if (n < 0)
    fprintf (stderr, 
	     "* Warning *: vec_alloc(): Requested number of "\
	     "bytes is negative.\n"); 
    
  if (x->vec != NULL)
    fprintf (stderr, 
	     "* Warning *: ******* MEMORY LEAK ******\n"); 

  if (n == 0)
     x->vec = (double *) malloc (sizeof(double) );
  else
     x->vec = (double *) malloc (sizeof(double) * (n));
  if (x->vec == NULL)
    {
      fprintf (stderr, 
	       "* Warning *: vec_alloc(): Out of memory (%ld bytes)\n",
	       (long) sizeof(double) * (n)); 
      exit (8);
    } 
  else 
    {
      x->len = n;
    }
  for(i=0;i<n;++i) x->vec[i]=0.;  /* initializing  */

  return;
}

/*  ------------------------ */

void vec_free(Vector *x)
{
  if (x->len > 0 && x->vec != NULL) 
    {
      free(x->vec);
      x->vec = NULL;
      x->len = 0;
    }
  return;
}

/*  ------------------------ */

/************************
void example(Vector x)
{
Vector x;

x.vec = malloc(200*sizeof(double));
x.len = 200;
}
*************************/


/*  --------------------------- */
int setvec(Vector *vector, double val)
     /*   function sets same value into each element of vector */
{
  int i, n;
  
  n=vector->len;
  for (i = 0; i < n; ++i)
    vector->vec[i] = val;
  
  return(n);
}

# if 0
/*----------------------------*/

Vector * index(Vector *vec, Vector *index)
{
  Vector * x;
  int i, n;
  
  n=index->len;
  
  x = (Vector *) malloc (sizeof(Vector));
  if (x == NULL)
    {
      fprintf (stderr, "* Warning *: Out of memory\n"); 
      exit (8);
    }
  
  vec_alloc(x, n);
  
  for  (i = 0; i < n; ++i)
    x->vec[i]=vec->vec[(int)index->vec[i]];
  
  return(x);
}

#endif
